/*
 * Copyright (c) 2005 DocJava, Inc. All Rights Reserved.
 */
package addbk.JAddressBook;


import gui.run.RunButton;
import gui.run.RunCheckBox;
import gui.run.RunTextField;
import gui.In;

import javax.swing.*;
import java.awt.*;


public abstract class RunFindDialog
        extends JDialog implements Runnable {

    private FindBean findBean = FindBean.restore();

    public RunFindDialog() {
        setModal(true);
        init();
    }

    private void init() {
        setTitle("Find Dialog");
        Container c = getContentPane();
        c.setLayout(new BorderLayout());
        c.add(new RunTextField(findBean.getFindString(), 20) {
            public void run() {
                findBean.setFindString(getText());
                RunFindDialog.this.run();
            }
        }, BorderLayout.NORTH);


        c.add(getCheckboxPanel(), BorderLayout.CENTER);
        c.add(getButtonPanel(), BorderLayout.SOUTH);

        setContentPane(c);
    }

    private JPanel getCheckboxPanel() {
        JPanel jp = new JPanel();
        jp.setBorder(BorderFactory.createEtchedBorder());
        jp.setLayout(new GridLayout(2, 0));
        jp.add(new RunCheckBox("In Name", findBean.isInName()) {
            public void run() {
                findBean.setInName(isSelected());
            }
        });
        jp.add(new RunCheckBox("In Address", findBean.isInAddress()) {

            public void run() {
                findBean.setInAddress(isSelected());
            }
        });
        jp.add(new RunCheckBox("In Info.", findBean.isInInfo()) {
            public void run() {
                findBean.setInInfo(isSelected());
            }
        });
        jp.add(new RunCheckBox("In Phone", findBean.isInPhone()) {
            public void run() {
                findBean.setInPhone(isSelected());
            }
        });
        return jp;
    }

    private JPanel getButtonPanel() {
        JPanel jp = new JPanel();

        jp.setLayout(new FlowLayout());
        jp.add(new RunButton("[Help") {
            public void run() {
                In.message("Hello world");
            }
        });
        jp.add(new RunButton("[Find") {
            public void run() {
                findBean.save();
                RunFindDialog.this.run();
            }
        });
        jp.add(new RunButton("[Cancel") {
            public void run() {
                RunFindDialog.this.setVisible(false);
            }
        });
        return jp;
    }


    public FindBean getFindBean() {
        return findBean;
    }


    public static void main(String[] args) {
        RunFindDialog dialog = new RunFindDialog() {
            public void run() {
                System.out.println(getFindBean());
            }
        };
        dialog.pack();
        dialog.show();
    }


}