package addbk.JAddressBookPSU;

import gui.ClosableJFrame;
import gui.layouts.VerticalFlowLayout;
import gui.run.RunButton;
import gui.run.RunLabel;

import javax.swing.*;
import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: Paul
 * Date: Apr 3, 2005
 * Time: 1:34:04 PM
 * To change this template use File | Settings | File Templates.
 */
public class AddressBookIndexFrame extends ClosableJFrame {
    AddressBookMediator abm = AddressBookMediator.getAddressBookMediator();
    JPanel addrListingPanel = getIndexPanel();
    JPanel functionButtonPanel;
    JPanel alphaIndexPanel;

    static String currentButtonLabel = null;


    JPanel nrp = getButtonControlPanel();

    private JPanel getButtonControlPanel() {
        JPanel jp = new JPanel();
        jp.setLayout(new FlowLayout());
        jp.add(new RunButton("Find") {
            public void run() {
                System.out.println("Find");
            }
        });
        jp.add(new RunButton("Edit") {
            public void run() {
                System.out.println("Navigate records panel: Edit");
                abm.edit();
            }
        });
        jp.add(new RunButton("New") {
            public void run() {
                System.out.println("New");
            }
        });
        jp.add(new RunButton("Prev. Page") {
            public void run() {
                System.out.println("Prev. Page");
            }
        });
        jp.add(new RunButton("Next Page") {
            public void run() {
                System.out.println("Next Page");
            }
        });
        return jp;
    }

    AddressBookIndexFrame() {


        alphaIndexPanel = getLetterPanel();
//        functionButtonPanel = getButtonControlPanel();
        functionButtonPanel = nrp;
        Container c = getContentPane();
        c.setLayout(new BorderLayout());
        c.add("South", functionButtonPanel);
        c.add("East", alphaIndexPanel);
        c.add("Center", addrListingPanel);
    }

    private static JPanel getLetterPanel() {
        JPanel jp = new JPanel() {
            public Dimension getPreferredSize() {
                return new Dimension(20, 100);
            }

            public Dimension getMinimumSize() {
                return getPreferredSize();
            }
        };
        jp.setLayout(new GridLayout(0, 1));

        for (int j = 0; j < 26; j++)
            jp.add(new RunLabel("  " + (char) (('a' + j)) + "") {
                public void run() {
                    System.out.println(getText());
                }
            });
        return jp;
    }

    static void setCurrentLabel(String label) {
        currentButtonLabel = label;
    }

    private JPanel getIndexPanel() {
        JPanel jp = new JPanel();
        jp.setLayout(new VerticalFlowLayout(0, 9));
        AddressRecord ar[] = abm.getAbdb().getAddresses();
        for (int k = 0; k < ar.length; ++k) {
            final AddressRecord r = ar[k];
            final String name = r.getName();
            jp.add(new RunLabel(name) {
                public void run() {
                    System.out.println(name);
                    abm.setStorageRecord(r);
                }
            });
        }
        return jp;
    }

    public static void main(String[] args) {
        AddressBookIndexFrame abif = new AddressBookIndexFrame();
        abif.setSize(400, 400);
        abif.setVisible(true);
    }
}
