package addbk.JAddressBookPSU;

import gui.run.RunMenu;
import gui.run.RunMenuBar;
import gui.run.RunMenuItem;
import gui.run.RunButton;

import javax.swing.*;
import java.awt.*;


public final class AddressBookMediator {
    private static AddressBookMediator abm = new AddressBookMediator();
    private AddressRecord storageRecord = new AddressRecord();

    private AddressBookDatabase abdb = null;

    private AddressBookIndexFrame abif = null;//PSU
    private AddressBookSearchFrame absf = null;

    private AddressBookMediator() {

        abdb = new AddressBookDatabase();
        absf = new AddressBookSearchFrame();

        //PSU
//        abdb.csvMerge();
//        abif = new AddressBookIndexFrame(getNavigateRecordsPanel(),this);
//        abif.setVisible(true);

//        absf = new AddressBookSearchFrame();

    }

    public AddressBookSearchFrame getAddressBookSearchFrame(){
        return absf;
    }
    public DialPhoneNavigationJPanel getDialPhoneNavigationPanel(){
        return new DialPhoneNavigationJPanel(this);
    }


    public static AddressBookMediator getAddressBookMediator() {
        return abm;
    }

    public void nextRecord() {
        abdb.incrementRecord();
        AddressRecord addressRecord = abdb.getAddressRecord();
        setStorageRecord(addressRecord);

    }

    public void prevRecord() {
        abdb.decrementRecord();
        AddressRecord addressRecord = getAbdb().getAddressRecord();
        setStorageRecord(addressRecord);

    }

    public void addRecord() {



        setIndexItems();

    }

    public void deleteCurrentRecord() {
        abdb.deleteCurrentRecord();
        setIndexItems();
        setStorageRecord(abdb.getAddressRecord());
    }

    public void revertRecord() {
        abdb.saveCurrentRecord(getStorageRecord());
        setStorageRecord(abdb.getAddressRecord());


    }


    public void toggleIndexDisplay() {
        // todo display index here
        System.out.println("toggleIndexDisplay");
        setIndexItems();
        if(abif.isVisible()){
            abif.setVisible(false);
        }
        else{
            abif.setVisible(true);
        }
    }

    public void setIndexItems() {
        // this should be in the index todo
        if(abif == null){
            abif = new AddressBookIndexFrame();
        }
    }

    public void setRecord(int i) {
        abdb.setRecordNumber(i);

        setStorageRecord(abdb.getAddressRecord());
    }


    public AddressRecord getStorageRecord() {
        return storageRecord;
    }

    public void setStorageRecord(AddressRecord storageRecord) {
        System.out.println("Setting storage record for " + storageRecord.getName());
        this.storageRecord =
                storageRecord;
    }



    public AddressBookDatabase getAbdb() {
        return abdb;
    }





    public RunMenuBar getRunMenuBar() {
        RunMenuBar rmb = new RunMenuBar();
        RunMenu fileMenu =
                new RunMenu("[File");
        fileMenu.add(new RunMenuItem("[open gzipped db") {
            public void run() {
                abdb.openGzippedDb();

                setRecord(0);
                setIndexItems();
            };
        });
        fileMenu.add(new RunMenuItem("[save gzipped db") {
            public void run() {
                abdb.saveGzippedDb();
            };
        });
        fileMenu.add(new RunMenuItem("[merge csv") {
            public void run() {
                abdb.csvMerge();
                setRecord(0);
                setIndexItems();
            };
        });

        fileMenu.add(new RunMenuItem("[export csv") {
            public void run() {
                abdb.csvExport();
            };
        });
        fileMenu.add(new RunMenuItem("[xml out") {
            public void run() {
                abdb.saveAsXml();
            };
        });
        fileMenu.add(new RunMenuItem("[quit{control q}") {
            public void run() {
                System.exit(0);
            };
        });
        rmb.add(fileMenu);
        return rmb;
    }

    public void edit() {
        System.out.println("mediator: edit");

    }

    public void done() {
        System.out.println("implement done with edit here");


        //todo finish this
    }

    public void next() {
        System.out.println("implement next here");
        abdb.incrementRecord();

        //todo finish this
    }

    public void index() {
        System.out.println("implement index here");
        toggleIndexDisplay();
        //todo finish this
    }

    public void previous() {
        System.out.println("previous");
        abdb.decrementRecord();
    }
    public JPanel getNavigationJPanel() {
        JPanel jp = new JPanel();
        jp.setLayout(new GridLayout(0, 1));
        jp.add(new RunButton("[Previous") {
            public void run() {
                previous();
            }
        });
        jp.add(new RunButton("[next") {
            public void run() {
                next();
            }
        });
        jp.add(new RunButton("[edit") {
            public void run() {
                edit();
            }
        });
        jp.add(new RunButton("[done") {
            public void run() {
                done();
            }
        });
        jp.add(new RunButton("[index") {
            public void run() {
                index();
            }
        });
        return jp;
    }
}
